From eaa186326e914c0297b4ea38a8a371d2590200ec Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:40:40 +0000
Subject: [PATCH 867/1001] Add a component to load the existing feed data dynamically


---

diff --git a/hubs/static/client/app/components/feed/Actions.jsx b/hubs/static/client/app/components/feed/Actions.jsx
index c481377..69890f1 100644
--- a/hubs/static/client/app/components/feed/Actions.jsx
+++ b/hubs/static/client/app/components/feed/Actions.jsx
@@ -3,45 +3,6 @@ import React from 'react';
 
 export default class Actions extends React.Component {
 
-  constructor(props) {
-    super(props);
-    this.save = this.save.bind(this);
-    this.delete = this.delete.bind(this);
-  }
-
-  save() {
-    const payload = {
-      link: this.props.item.link,
-      markup: this.props.item.markup,
-      secondary_icon: this.props.item.secondary_icon,
-      dom_id: this.props.item.dom_id,
-    };
-
-    $.ajax({
-      type: 'POST',
-      url: this.props.options.saveUrl,
-      data: JSON.stringify(payload),
-      contentType: 'application/json',
-    }).done(() => {
-      const id = `#save-${this.props.item.dom_id}`;
-      const $saveBtn = $(id);
-      $saveBtn.removeClass('btn-primary').addClass('btn-success');
-      $saveBtn.text('Saved');
-    });
-  }
-
-  delete() {
-    $.ajax({
-      type: 'DELETE',
-      url: `${this.props.options.saveUrl}${this.props.item.idx}/`,
-    }).done((resp) => {
-      if (resp.status_code === 200) {
-        const $notification = $(`#${this.props.item.dom_id}`);
-        $notification.closest('.card-block').remove();
-      }
-    });
-  }
-
   render() {
     var buttonProps = {
       id: `save-${this.props.item.dom_id}`,
@@ -50,16 +11,16 @@ export default class Actions extends React.Component {
     var buttonText;
 
     if (this.props.item.saved) {
-      if (this.props.options.delete) {
-        buttonProps.className += "btn-danger";
-        buttonProps.onClick = this.delete;
-        buttonText = "Remove";
-      } else {
-        buttonText = "Saved";
-      }
+      buttonProps.className += "btn-success";
+      buttonProps.onClick = () => {
+        this.props.handleUnsave(this.props.item);
+      };
+      buttonText = "Saved";
     } else {
       buttonProps.className += "btn-primary";
-      buttonProps.onClick = this.save;
+      buttonProps.onClick = () => {
+        this.props.handleSave(this.props.item);
+      };
       buttonText = "Save";
     }
 
diff --git a/hubs/static/client/app/components/feed/ItemsGetter.jsx b/hubs/static/client/app/components/feed/ItemsGetter.jsx
new file mode 100644
index 0000000..1ba1c4f
--- /dev/null
+++ b/hubs/static/client/app/components/feed/ItemsGetter.jsx
@@ -0,0 +1,104 @@
+import React from 'react';
+
+
+export default class ItemsGetter extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.state = {
+      sseError: false,
+      loading: false,
+    };
+    this.source = null;
+    this.setupSource = this.setupSource.bind(this);
+    this.handleEventError = this.handleEventError.bind(this);
+    this.loadExistingFromServer = this.loadExistingFromServer.bind(this);
+  }
+
+  componentDidMount() {
+    this.loadExistingFromServer();
+  }
+
+  componentWillUnmount() {
+    this.serverRequest.abort();
+    if (this.source !== null) {
+      this.source.removeEventListener('error', this.handleEventError);
+      this.source.close();
+    }
+  }
+
+  componentDidUpdate(prevProps, prevState) {
+    if (this.props.sseActive && !this.source) {
+      // Only setup the source after the initial loading, or new elements may
+      // be overwritten by the call to this.props.handleInitialData().
+      this.setupSource();
+    }
+  }
+
+  setupSource() {
+    if (!this.props.urls.sse) {
+      // Auto-update is disabled.
+      return;
+    }
+
+    if (!window.EventSource) {
+      this.setState({
+        sseError: ("Cannot auto-update the feed, you will have to refresh "
+                  +"the page manually to see new elements.")
+      });
+      return;
+    }
+
+    this.source = new EventSource(this.props.urls.sse);
+    this.source.addEventListener('error', this.handleEventError);
+    this.source.onmessage = (resp) => {
+      this.props.handleMessage(JSON.parse(resp.data));
+    };
+  }
+
+  handleEventError() {
+    this.setState({
+      sseError: "There was an error retrieving the new elements."
+    });
+  }
+
+  loadExistingFromServer() {
+    this.setState({loading: true});
+    this.serverRequest = $.ajax({
+      url: this.props.urls.content,
+      method: 'GET',
+      dataType: 'json',
+      cache: false,
+      success: (data, textStatus, jqXHR) => {
+        this.props.handleInitialData(data.data);
+      },
+      error: (xhr, status, err) => {
+        console.error(status, err.toString());
+      },
+      complete: (xhr, status) => {
+        this.setState({loading: false});
+      },
+    });
+  }
+
+  render() {
+    return (
+      <div>
+        {this.props.children}
+        <div
+          className="loading mx-auto"
+          style={{display: this.state.loading ? "block" : "none"}}
+          ></div>
+        { (this.state.sseError !== false) &&
+          <div className="alert alert-warning">
+            {this.state.sseError}
+          </div>
+        }
+      </div>
+    );
+  }
+
+}
+
+
+// vim: set ts=2 sw=2 et:
diff --git a/hubs/static/client/app/components/feed/Markup.jsx b/hubs/static/client/app/components/feed/Markup.jsx
index daf2d84..72f88c9 100644
--- a/hubs/static/client/app/components/feed/Markup.jsx
+++ b/hubs/static/client/app/components/feed/Markup.jsx
@@ -25,7 +25,9 @@ export default class Markup extends React.Component {
         >
         </h4>
         {timestamp}
-        <Actions {...this.props} />
+        { (this.props.handleSave) &&
+          <Actions {...this.props} />
+        }
       </div>
     );
   }
diff --git a/hubs/static/client/app/widgets/feed/Widget.jsx b/hubs/static/client/app/widgets/feed/Widget.jsx
index 5ee232f..38a006d 100644
--- a/hubs/static/client/app/widgets/feed/Widget.jsx
+++ b/hubs/static/client/app/widgets/feed/Widget.jsx
@@ -1,4 +1,5 @@
 import React from 'react';
+import ItemsGetter from '../../components/feed/ItemsGetter.jsx';
 import Feed from '../../components/feed/Feed.jsx';
 
 
@@ -7,47 +8,98 @@ export default class Widget extends React.Component {
   constructor(props) {
     super(props);
     this.state = {
-      items: this.props.items,
-      sse: true,
+      items: [],
+      sseActive: false,
     };
-    this.componentDidMount = this.componentDidMount.bind(this);
-    this.componentWillUnmount = this.componentWillUnmount.bind(this);
+    this.handleInitialData = this.handleInitialData.bind(this);
     this.handleMessage = this.handleMessage.bind(this);
-    this.source = null;
+    this.handleSave = this.handleSave.bind(this);
+    this.handleUnsave = this.handleUnsave.bind(this);
   }
 
-  componentDidMount() {
-    // If it wasn't instantiated with a url or an error happened, bail
-    if (!this.props.url || !this.state.sse) {
-      return;
-    }
-    this.source = (!!window.EventSource) ? new EventSource(this.props.url) : null;
-    if (!this.source) {
-      return;
-    }
-    this.source.addEventListener('error', () => {
-      this.state.sse = false;
-    }, false);
-    this.source.onmessage = resp => {
-      this.handleMessage(JSON.parse(resp.data));
-    };
-  }
-
-  componentWillUnmount() {
-    if (this.source) { this.source.close(); }
+  handleInitialData(data) {
+    // Only activate SSE after the initial loading, or new elements may
+    // be overwritten.
+    this.setState({
+      items: data,
+      sseActive: true,
+    });
   }
 
   handleMessage(msg) {
-    if (this.state.items.length >= this.props.options.messageLimit) {
+    if (this.state.items.length >= this.props.messageLimit) {
       this.state.items.pop();
     }
     this.state.items.unshift(msg);
     this.setState({items: this.state.items});
   }
 
+  handleSave(item) {
+    if (!this.props.urls.save) { return; }
+    const payload = {
+      link: item.link,
+      markup: item.markup,
+      secondary_icon: item.secondary_icon,
+      dom_id: item.dom_id,
+    };
+    $.ajax({
+      type: 'POST',
+      url: this.props.urls.save,
+      data: JSON.stringify(payload),
+      contentType: 'application/json',
+      success: () => {
+        this.setState((prevState, props) => {
+          var items = prevState.items.map((currentItem) => {
+            if (currentItem.dom_id === item.dom_id) {
+              currentItem.saved = true;
+            }
+            return currentItem;
+          })
+          return {items};
+        });
+      },
+    });
+  }
+
+  handleUnsave(item) {
+    if (!this.props.urls.save) { return; }
+    var updateItemState = (item) => {
+      this.setState((prevState, props) => {
+        var items = prevState.items.map((currentItem) => {
+          if (currentItem.dom_id === item.dom_id) {
+            currentItem.saved = false;
+          }
+          return currentItem;
+        });
+        return {items};
+      });
+    };
+    if (item.idx) {
+      // Already saved
+      $.ajax({
+        type: 'DELETE',
+        url: `${this.props.urls.save}${item.idx}/`,
+        success: () => { updateItemState(item) },
+      });
+    } else {
+      updateItemState(item);
+    }
+  }
+
   render() {
     return (
-        <Feed items={this.state.items} {...this.props} />
+      <ItemsGetter
+        sseActive={this.state.sseActive}
+        urls={this.props.urls}
+        handleMessage={this.handleMessage}
+        handleInitialData={this.handleInitialData}
+        >
+        <Feed
+          items={this.state.items}
+          handleSave={this.handleSave}
+          handleUnsave={this.handleUnsave}
+          />
+      </ItemsGetter>
     );
   }
 
diff --git a/hubs/widgets/feed/__init__.py b/hubs/widgets/feed/__init__.py
index ebea21b..6f7d07a 100644
--- a/hubs/widgets/feed/__init__.py
+++ b/hubs/widgets/feed/__init__.py
@@ -39,10 +39,28 @@ class BaseView(WidgetView):
         # Avoid circular import
         from hubs.app import app
         username = instance.config["username"]
-        feed_url = app.config['SSE_URL'] + username
+        sse_url = app.config['SSE_URL'] + username
         return dict(
             title=self.widget.label,
-            matches=[],
             message_limit=instance.config["message_limit"],
-            feed_url=feed_url,
+            sse_url=sse_url,
             )
+
+
+class ExistingView(WidgetView):
+
+    name = "existing"
+    url_rules = ["/existing"]
+    json = True
+
+    def get_context(self, instance, *args, **kwargs):
+        username = instance.config["username"]
+        # Mock data:
+        import hubs.stream
+        import json
+        stream = hubs.stream.Stream()
+        existing = json.loads(stream.get_json())
+        return {
+            "status": "OK",
+            "data": existing,
+        }
